package me.totalfreedom.totalfreedommod.command;

import java.util.Objects;
import me.totalfreedom.totalfreedommod.rank.Rank;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.kyori.adventure.text.minimessage.tag.resolver.Placeholder;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(rank = Rank.OP, source = SourceType.BOTH)
@CommandParameters(description = "Manage operators", usage = "/<command> <count | purge>")
public class Command_ops extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length != 1)
        {
            return false;
        }

        if (args[0].equalsIgnoreCase("count"))
        {
            int totalOps = server.getOperators().size();
            long onlineOps = server.getOnlinePlayers().stream().filter(player -> player.isOp()).count();

            msgNew("Online OPs: <online>", Placeholder.unparsed("online", String.valueOf(onlineOps)));
            msgNew("Offline OPs: <offline>", Placeholder.unparsed("offline", String.valueOf(totalOps - onlineOps)));
            msgNew("Total OPs: <total>", Placeholder.unparsed("total", String.valueOf(totalOps)));
            return true;
        }

        if (args[0].equalsIgnoreCase("purge"))
        {
            if (!plugin.al.isAdmin(sender))
            {
                noPerms();
                return true;
            }

            FUtil.adminAction(sender.getName(), "Purging all operators", true);

            server.getOperators().forEach(operator ->
            {
                operator.setOp(false);

                if (operator.isOnline())
                {
                    msg(Objects.requireNonNull(operator.getPlayer()), YOU_ARE_NOT_OP);
                }
            });

            return true;
        }
        return false;
    }
}